

proc define-DAC {} {
  global resource mname IPslot IPslots

  set mname IPDAC
  set slot  [lsearch $IPslots $IPslot(IPDAC)]

  log "deleting all IP-DAC registers"
  EG "register :pattern '/$resource/$mname.*' !delete"

#     ID
      define-register xIP ManID        "-s $slot -o 0x09 -d id -p ro -w 8 -zx"
      define-register xIP ModID        "-s $slot -o 0x0b -d id -p ro -w 8 -zx"

#    DAC 1
      define-register xIP c1.DAC        "-s $slot -o 0x04 -d io -p wo -w 16 -zx"
      define-register xIP c1.offset     "-s $slot -o 0x19 -d id -p ro -w 8 -zx"
      define-register xIP c1.gain       "-s $slot -o 0x25 -d id -p ro -w 8 -zx"

#    DAC 2
      define-register xIP c2.DAC        "-s $slot -o 0x02 -d io -p wo -w 16 -zx"
      define-register xIP c2.offset     "-s $slot -o 0x1b -d id -p ro -w 8 -zx"
      define-register xIP c2.gain       "-s $slot -o 0x27 -d id -p ro -w 8 -zx"

#    DAC 3
      define-register xIP c3.DAC        "-s $slot -o 0x0c -d io -p wo -w 16 -zx"
      define-register xIP c3.offset     "-s $slot -o 0x1d -d id -p ro -w 8 -zx"
      define-register xIP c3.gain       "-s $slot -o 0x29 -d id -p ro -w 8 -zx"

#    DAC 4
      define-register xIP c4.DAC        "-s $slot -o 0x0a -d io -p wo -w 16 -zx"
      define-register xIP c4.offset     "-s $slot -o 0x1f -d id -p ro -w 8 -zx"
      define-register xIP c4.gain       "-s $slot -o 0x2b -d id -p ro -w 8 -zx"

#    DAC 5
      define-register xIP c5.DAC        "-s $slot -o 0x14 -d io -p wo -w 16 -zx"
      define-register xIP c5.offset     "-s $slot -o 0x21 -d id -p ro -w 8 -zx"
      define-register xIP c5.gain       "-s $slot -o 0x2d -d id -p ro -w 8 -zx"

#    DAC 6
      define-register xIP c6.DAC        "-s $slot -o 0x12 -d io -p wo -w 16 -zx"
      define-register xIP c6.offset     "-s $slot -o 0x19 -d id -p ro -w 8 -zx"
      define-register xIP c6.gain       "-s $slot -o 0x2f -d id -p ro -w 8 -zx"
}
